      subroutine imgfilter(ffta, hklx, hkly, newfft, radius)
      
      implicit none

      integer, intent(in) :: hklx, hkly
      real, intent(in)    :: ffta(0:hklx,-hkly:hkly)
      real, intent(in)    :: radius
      real, intent(out)   :: newfft(0:hklx,-hkly:hkly)
      
      double precision fftb(0:hklx,-hkly:hkly)
      integer x, y, bx, by, i,j,k, x1, x2, x3, delta(3)
      integer wind
      parameter (wind=6)
      integer bsizex, bsizey
      real    y1, y2, y3, b, c, d, step, b1,c1,d1, radsq
      double precision maxcc, mincc, dis, dis1
      
      goto 1001
C     box convolution
      bsizex = hklx 
      bsizey = hkly
      do y = -hkly, hkly
         do x = 0, hklx
            fftb(x,y)=0.0
            
            do bx = -bsizex + x, 0
               do by = -bsizey + y, bsizey + y
                  if (by >= -hkly .and. by <= hkly) then
                     fftb(x,y) = fftb(x,y) + ffta(-bx,by)
                  endif
               enddo
            enddo
            
            do bx = 0, bsizex + x
               if (bx <= hklx) then
                  do by = -bsizey + y, bsizey + y
                     if (by >= -hkly .and. by <= hkly) then
                        fftb(x,y) = fftb(x,y) + ffta(bx,by)
                     endif
                  enddo
               endif
            enddo
            
         enddo
      enddo
      
      do y = -hkly, hkly
         do x = 0, hklx
            newfft(x,y)= ffta(x,y) - fftb(x,y)/(2*bsizex+1)/(2*bsizey+1)
         enddo
      enddo
      
C     get 1D minimum along x direction
 1001 continue
      bsizex = nint(sqrt(radius))/2
      bsizey = nint(radius)
      i = 1
      do x = bsizey, hklx
         do y = x-bsizex, x+bsizex
            if (ffta(x,0) > ffta(y,0)) goto 1100
         enddo
C     find a local minumum
         if (i == 1) then 
            x1 = x
            y1 = ffta(x1,0)
            i = i + 1
         else if (i == 2) then
            x2 = x
            y2 = ffta(x1,0)
            i = i + 1
         else
            x3 = x
            y3 = ffta(x2,0)
            goto 1200
         endif
 1100    continue         
      enddo
 1200 continue         
C     suppose the background is y=b*exp(-dstar**2*c - dstar*d) to fit the b,c,d
      c = (log(y1/y2)/(x2-x1)-log(y2/y3)/(x3-x2))/(x3-x1)
      d = log(y1/y2)/(x2-x1) - c*(x2+x1)
      b = y1/exp(-x1*d - x1*x1*c)
      print *, 'x1=',x1,y1,x2,y2,x3,y3, 'b=',b,'c=',c,'d=',d   
      
      maxcc = 1.0E37
      step = 0.1
      
 1000 delta(1) = -wind
      delta(2) = wind
      delta(3) = wind
      mincc = 1.0E38
      
      do i = -wind, wind
         b1 = b * ( 1. + i * step)
         do j = -wind, wind
            c1 = c * ( 1. + j * step)
            do k = -wind, wind
               d1 = d * ( 1. + k * step)
               
               dis = 0.0
               do y = -hkly, hkly
                  do x = 0, hklx
                     radsq = real(x**2 + y**2)
C     if (radsq >= radius*radius) then
                     dis1 = (ffta(x,y) - 
     +                    b1*exp(-c1*radsq -d1*sqrt(radsq))) / ffta(x,y)
                     if (dis1 < 0.0) goto 2000
                     dis = dis + dis1
C     endif
                  enddo
               enddo
               if (dis < mincc) then
                  mincc = dis
                  delta(1) = i
                  delta(2) = j
                  delta(3) = k
               endif
 2000          continue              
               
            enddo
         enddo
      enddo
      
      if ((delta(1).ne.0).or.(delta(2).ne.0).or.(delta(3).ne.0)) then
         b = b * ( 1 + delta(1) * step)
         c = c * ( 1 + delta(2) * step) 
         d = d * ( 1 + delta(3) * step)
         print *, 'b=',b,'c=',c,'d=',d, 'mincc=',mincc  
         goto 1000     
      endif
      print *, 'b=',b,'c=',c,'d=',d, 'mincc=',mincc  
      if (step >= 0.001) then
         step = step / (wind+1)
         goto 1000
      endif
C     substract the background 
      do y = -hkly, hkly
         do x = 0, hklx
            radsq = real(x**2 + y**2)
            newfft(x,y)=ffta(x,y)-b*exp(-c*radsq -d*sqrt(radsq))
         enddo
      enddo

      end subroutine imgfilter
