/* pifInfo.c - Just read in the PIF file off the disk and
 * print header info.
 * 
 * Rob Ashmore
 * Purdue University
 * April 2004
*/
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "../include/common.h"
#include "../include/libPIF.h"


typedef struct __imgHead_t__
  {/* IMAGEHEAD_T */
    int    header;
    int    image;
  }/* IMAGEHEAD_T */ imgHead_t;

pifHead_t pifHead;


int main(int argc, char **argv)
{/* MAIN */
  int       i,j,k,thisImg;
  fString_t fName,readWrite;
  int       luNum;
  char      inFile[2048];
  forPifHead_t  thisHead;

  banner("pifInfo");

  if(argc < 2)
    {/* usage */
      printf("\nUSAGE:  pifInfo pifFileName <imgNumber>\n");
      printf("\npifInfo prints info in PIF the header.\n");
      printf("   <imgNumber> is optional and if absent defaults to 1\n\n");
      exit(0);
    }/* usage */

  if(argc>=3)
    thisImg = (int)strtod(argv[2],0);
  else thisImg = 1;

  sprintf(inFile,argv[1]);
  fName.addr = (char *)malloc(sizeof(char)*1024);
  readWrite.addr = (char *)malloc(sizeof(char)*64);
  sprintf(fName.addr,inFile);
  sprintf(readWrite.addr,"r");
  i= thisHead.luNum = 4;
  pif_open_(fName.addr, &i, readWrite.addr);

  pif_read_gh_(&thisHead);
  thisHead.imgNum = thisImg;
  pif_read_dh_(&thisHead);


  pif_list_head_(&thisHead);

  /* OLDWAY
  printf("[%d][%d][%d][%d]\n",
	 thisHead.numCols/2,
	 thisHead.borderWidth,
	 thisHead.borderType,
	 thisHead.nimg	 
	 );
  ***********/

  pif_close_(&thisHead.luNum);
  free(fName.addr);


}/* MAIN */




/* End of pifInfo.c */
